﻿using System.Collections.Generic;
using Startup.DataContract.Int32;
using Startup.DataContract.String;

namespace Startup.DataContract.Basic
{
	public class DataContractManager
	{
		private static DataContractManager _instance;
		public static DataContractManager Instance
		{
			get
			{
				if (_instance == null)
					_instance = new DataContractManager();

				return _instance;
			}
		}

		private readonly DataContractBase[] _settingsCollection = new DataContractBase[]
		{
			new MaleNameContract(),
			new FemaleNameContract(),
			new LastNameContract(),
			new PortContract(),
			new HostContract()
		};

		public IList<DataContractBase> SettingsCollection
		{
			get { return _settingsCollection; }
		}
	}
}
