﻿using System;

namespace Startup.Project.Classes
{
	public abstract class ClassBase
	{
		private readonly string _name;
		private readonly string _namespace;

		internal ClassBase(string name, string namespaceName)
		{
			if (string.IsNullOrEmpty(name))
				throw new ArgumentNullException("name");
			if (string.IsNullOrEmpty(namespaceName))
				throw new ArgumentNullException("namespaceName");
			
			_name = name;
			_namespace = namespaceName;
		}

		public string Name
		{
			get { return _name; }
		}

		internal string Namespace
		{
			get { return _namespace; }
		}

		public override string ToString()
		{
			return string.Format("{0}.{1}", _namespace, _name);
		}
	}
}
