﻿using System;
using System.Collections.Generic;
using Startup.Base.Utils;
using Startup.Project.Algorithm;
using Startup.Project.Utils;

namespace Startup.Project.Interfaces
{
	public class ToolbarContainer : UiContainer
	{
		private readonly List<CommandDefinition> _commands = new List<CommandDefinition>();

		public ToolbarContainer(int childrenCount)
			: base(childrenCount)
		{
		}

		internal override string SaveToString(UiGridCombinerHelper gridContext)
		{
			TabStringBuilder builder = new TabStringBuilder();
			
			builder.AddLine("<ToolBar>");

			for (int index = 0; index < _commands.Count; index++)
			{
				CommandDefinition command = _commands[index];
				builder.Tab().AddLine('<' + string.Format("Button Content=\"{0}\" Command=\"<Binding {1}>\"/", command.DisplayName, command.CommandName).Replace('<', '{').Replace('>', '}') + '>');
			}
			
			builder.AddLine("</ToolBar>");
			return builder.ToString();
		}

		public void AddCommand(CommandDefinition command)
		{
			if (command == null) 
				throw new ArgumentNullException("command");
			
			_commands.Add(command);
		}

		public List<CommandDefinition> Commands
		{
			get { return _commands; }
		}
	}
}
