﻿using Startup.Base.Utils;
using Startup.Project.Utils;

namespace Startup.Project.Interfaces
{
	public class ViewLinkContainer : UiContainer
	{
		private readonly ViewBase _view;

		public ViewLinkContainer(ViewBase view) : base(0)
		{
			_view = view;
		}

		internal string Namespace
		{
			get { return _view.ModelClass.Namespace; }
		}
		
		internal string Name
		{
			get { return _view.Name; }
		}
		
		internal override string SaveToString(UiGridCombinerHelper gridContext)
		{
			TabStringBuilder builder = new TabStringBuilder();

			builder.AddLine("<{0}:{1} Grid.Row=\"{2}\" Grid.Column=\"{3}\" DataContext=\"{4}\" />", CSharpNameHelper.GetLocalFieldName(_view.Name), _view.Name, gridContext.CurrentRow, gridContext.CurrentColumn, "{ Binding " + _view.ViewModelClass.Name + '}');

			return builder.ToString();
		}
	}
}
