﻿using System;
using System.Globalization;

namespace Startup.Project.Utils
{
	public static class CSharpNameHelper
	{
		public static string GetLocalFieldName(string name)
		{
			if (string.IsNullOrEmpty(name))
				throw new ArgumentNullException("name");

			string firstChar = name[0].ToString(CultureInfo.InvariantCulture).ToLower();
			string tempName = name.Remove(0, 1).Insert(0, firstChar);

			tempName = tempName.Replace('<', '_');
			tempName = tempName.Replace('>', '_');
			tempName = tempName.Replace('.', '_');
			tempName = tempName.Replace(',', '_');
			tempName = tempName.Replace('?', '_');

			tempName = tempName.TrimStart('_');

			return tempName;
		}

		public static string GetFieldName(string name)
		{
			return "_" + GetLocalFieldName(name);
		}

		public static string GetPropertyName(string name)
		{
			string tempName = name.Replace('<', '_');
			tempName = tempName.Replace('>', '_');
			tempName = tempName.Replace('.', '_');
			tempName = tempName.Replace(',', '_');
			tempName = tempName.Replace('?', '_');

			tempName = tempName.TrimStart('_');

			string firstChar = tempName[0].ToString(CultureInfo.InvariantCulture).ToUpper();
			tempName = tempName.Remove(0, 1).Insert(0, firstChar);

			return tempName;
		}
	}
}
