﻿using System;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using Startup.Project.Classes;
using Startup.Project.Interfaces;
using Startup.Shell.Domain;

namespace Startup.Shell.ModelDesignerPreview
{
	public class TopPanelPreview : IDesignerPreview
	{
		public PreviewContainer TopChild { get; set; }
		public PreviewContainer BottomChild { get; set; }

		public TopPanelPreview()
		{
			TopChild = new PreviewContainer();
			BottomChild = new PreviewContainer();
		}

		public override ImageSource PreviewImage
		{
			get { return new BitmapImage(new Uri("/Startup.Shell;component/Resources/TopPanel.png", UriKind.RelativeOrAbsolute)); }
		}

		public override PreviewContainer[] Children
		{
			get { return new[] { TopChild, BottomChild }; }
		}

		public override IDesignerPreview CreateInstance()
		{
			return new TopPanelPreview();
		}

		public override UiContainer GetContainer(ClassBase dataContextType, StartupProperty property)
		{
			return new GridContainer(Orientation.Vertical, 20, 80);
		}
	}
}
